/*++

Module Name:

    queue.h

Abstract:

    This file contains the queue definitions.

Environment:

    Kernel-mode Driver Framework

--*/

EXTERN_C_START



typedef struct _TPORTOP
{
    USHORT Address;
    UCHAR Flags;
    UCHAR Size;
    DATA Data;
} TPORTOP, * PPORTOP;

//
// This is the context that can be placed per queue
// and would contain per queue information.
//
typedef struct _QUEUE_CONTEXT {

    PDEVICE_CONTEXT deviceContext;
    PPORTOP Data;

} QUEUE_CONTEXT, * PQUEUE_CONTEXT;

WDF_DECLARE_CONTEXT_TYPE_WITH_NAME(QUEUE_CONTEXT, QueueGetContext)

NTSTATUS
AIOWDM4QueueInitialize(
    _In_ WDFDEVICE Device
    );

void ForgetIRP(PIRP IRP);

//
// Events from the IoQueue object
//
EVT_WDF_IO_QUEUE_IO_DEVICE_CONTROL AIOWDM4EvtIoDeviceControl;
EVT_WDF_IO_QUEUE_IO_STOP AIOWDM4EvtIoStop;

EXTERN_C_END
